import { EventEmitter } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { BaseFilter } from '../shared/base.filter';
export declare abstract class BaseFilterComponent {
    filter: BaseFilter;
    myForm: FormGroup;
    filterOrders: FilterOrder[];
    currentOrder: string;
    displayFilter: boolean;
    onSearch: EventEmitter<BaseFilter>;
    onReset: EventEmitter<BaseFilter>;
    constructor();
    abstract createNewFilter(): BaseFilter;
    submit(value?: string): void;
    resetFilter(): boolean;
    postResetFilter(): void;
    changeOrder(newOrder: FilterOrder): void;
    readonly diagnostic: string;
}
export declare class FilterOrder {
    value: string;
    label: string;
    order: string[];
    constructor(value: string, label: string, order: string[]);
}
