"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var custom_validators_service_1 = require("../../shared/service/custom-validators.service");
var BaseFilterComponent = /** @class */ (function () {
    function BaseFilterComponent() {
        this.onSearch = new core_1.EventEmitter(); // se activará cuando pulsen en buscar
        this.onReset = new core_1.EventEmitter();
    }
    BaseFilterComponent.prototype.submit = function (value) {
        if (!this.myForm.valid) { //this.myForm.dirty puede que no lo hayamos tocado
            var errores = custom_validators_service_1.CustomValidators.validateForm(this.myForm);
            alert("El filtre de cerca cont\u00E9 les seg\u00FCents errades: " + errores.reduce(function (v1, v2) { return v1 + '\n' + v2; }, ''));
        }
        else {
            this.filter.pagina = 1; //cada vez que ejecutamos una búsqueda empezamos en la página 1
            this.onSearch.emit(this.filter); //comunicamos hacia arriba que debe realizarse la búsqueda
        }
    };
    BaseFilterComponent.prototype.resetFilter = function () {
        this.filter.reset();
        this.onReset.emit(this.filter);
        this.postResetFilter();
        return false;
    };
    BaseFilterComponent.prototype.postResetFilter = function () {
        this.filterOrders && this.filterOrders[0] && this.changeOrder(this.filterOrders[0]);
    };
    BaseFilterComponent.prototype.changeOrder = function (newOrder) {
        if (this.filterOrders) {
            this.filter.columnasOrdenacion = this.filterOrders.find(function (o) { return o.value === newOrder.value; }).order;
            this.currentOrder = newOrder.value;
        }
    };
    Object.defineProperty(BaseFilterComponent.prototype, "diagnostic", {
        get: function () { return JSON.stringify(this.filter); },
        enumerable: true,
        configurable: true
    });
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], BaseFilterComponent.prototype, "displayFilter", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseFilterComponent.prototype, "onSearch", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], BaseFilterComponent.prototype, "onReset", void 0);
    return BaseFilterComponent;
}());
exports.BaseFilterComponent = BaseFilterComponent;
var FilterOrder = /** @class */ (function () {
    function FilterOrder(value, label, order) {
        this.value = value;
        this.label = label;
        this.order = order;
    }
    return FilterOrder;
}());
exports.FilterOrder = FilterOrder;
//# sourceMappingURL=base-filter.component.js.map