"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
/**
 * Clase base mínima para cualquier componente.
 * @version 2.0
 */
var BaseComponent = /** @class */ (function () {
    function BaseComponent(messageService, toolbarService, componentId) {
        if (componentId === void 0) { componentId = "BASE"; }
        this.destroy$ = new rxjs_1.Subject();
        this.messageService = messageService;
        this.toolbarService = toolbarService;
        this.componentId = componentId;
        // console.log(`Soy el componente ${componentId}`);
    }
    BaseComponent.prototype.ngOnDestroy = function () {
        this.destroy$.next(true);
        this.destroy$.unsubscribe();
    };
    BaseComponent.prototype.resetData = function () {
        //this.errorMessage = '';
    };
    BaseComponent.prototype.updateToolbar = function () {
        // console.log(`invocación para updateToolbar del componente ${this.componentId}. Toolbar enviada:`);
        // console.log(this.toolbar);
        this.toolbarService && this.toolbarService.updateToolbar(this.componentId, this.toolbar);
    };
    BaseComponent.prototype.converToDate = function (fecha) {
        return new Date(fecha);
    };
    return BaseComponent;
}());
exports.BaseComponent = BaseComponent;
//# sourceMappingURL=base.component.js.map