"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
/**
 * Clase base que contiene lo mínimo necesario para almacenar un filtro de búsqueda.
 */
var BaseFilter = /** @class */ (function () {
    function BaseFilter(resultados, pagina) {
        this.resultados = resultados;
        this.pagina = pagina;
    }
    BaseFilter.prototype.reset = function () {
        this.resultados = BaseFilter.RESULTADOS_PAGE;
        this.pagina = BaseFilter.PAGE;
    };
    /**
     * Permite obtener los valores del filtro exceptuando las propiedades pagina y resultados. Útil para inicializar el FormGroup
     * con los valores del filtro sin traernos estas propiedades que no interesan que estén en el FormGroup
     */
    BaseFilter.prototype.formValues = function () {
        var values = utils_1.reject(this, ["pagina", "resultados"]);
        return values;
    };
    BaseFilter.RESULTADOS_PAGE = 20;
    BaseFilter.PAGE = 1;
    BaseFilter.PAGE_LINK_SIZE = 5;
    return BaseFilter;
}());
exports.BaseFilter = BaseFilter;
//# sourceMappingURL=base.filter.js.map