"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Actualiza el elemento de la lista en caso de que exista en dicha lista, o lo inserta en caso de que no exista
 * @param element objeto que queremos actualizar o insertar en la lista
 * @param list lista de elementos
 */
function upsertElement(element, list) {
    var find = false;
    if (!list)
        list = [];
    list.forEach(function (item, index) {
        if (item.id == element.id) {
            list[index] = element;
            find = true;
        }
    });
    if (!find) {
        list.push(element);
    }
    return list;
}
exports.upsertElement = upsertElement;
/**
 * Elimina el elemento de la lista
 * @param element elemento a eliminar de la lista
 * @param list lista de elementos
 */
function deleteElement(element, list) {
    return list.filter(function (item) { return item.id != element.id; });
}
exports.deleteElement = deleteElement;
/** Permite copiar las propiedades de un objeto exceptuando las propiedades indicadas en keys.
 * Util para obtener los valores del filtro exceptuando las propiedades pagina y resultados.
 * La copia se realiza mediante Object.assign por lo que hay que tenerlo en cuenta por temas de propiedades anidadas
 * @param obj objeto que queremos copiar
 * @param keys array de propiedades que no queremos copiar
 */
function reject(obj, keys) {
    return Object.keys(obj)
        .filter(function (k) { return !keys.includes(k); })
        .map(function (k) {
        var _a;
        return Object.assign({}, (_a = {}, _a[k] = obj[k], _a));
    })
        .reduce(function (res, o) { return Object.assign(res, o); }, {});
}
exports.reject = reject;
//# sourceMappingURL=utils.js.map