"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var router_1 = require("@angular/router");
var config_1 = require("../shared/data/config");
var configuracion_service_1 = require("../shared/service/configuracion.service");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var base_form_component_1 = require("../../base/component/base-form.component");
var custom_validators_service_1 = require("../../shared/service/custom-validators.service");
/**
 * Componente que implementa un formulario para insertar, modificar, eliminar y/o consultar un elemento de tipo Usuario.
 */
var ConfigFormComponent = /** @class */ (function (_super) {
    __extends(ConfigFormComponent, _super);
    function ConfigFormComponent(configService, router, activatedRoute, messageService, toolbarService, formBuilder) {
        var _this = _super.call(this, configService, router, activatedRoute, messageService, toolbarService) || this;
        _this.configService = configService;
        _this.router = router;
        _this.activatedRoute = activatedRoute;
        _this.messageService = messageService;
        _this.toolbarService = toolbarService;
        _this.formBuilder = formBuilder;
        _this.object = config_1.Config.newObject();
        _this.myForm = _this.formBuilder.group({
            'codigo': [_this.object.codigo, [forms_1.Validators.required, custom_validators_service_1.CustomValidators.etiquetaValidator]],
            'valor': [_this.object.valor, []]
        });
        return _this;
    }
    /** Inicializa la ficha: lee el elemento con el id indicado e inicializa el componente. */
    ConfigFormComponent.prototype.ngOnInit = function () {
        var _this = this;
        var id;
        this.subscribeParams = this.activatedRoute.params.subscribe(function (params) {
            _this.init(params['id']);
        });
    };
    /** Cierra la ficha: libera memoria, desvincula subscripciones, etc. */
    ConfigFormComponent.prototype.ngOnDestroy = function () {
        if (this.subscribeParams) {
            this.subscribeParams.unsubscribe(); // necesario para evitar memory leaks
        }
    };
    ConfigFormComponent.prototype.init = function (id) {
        _super.prototype.init.call(this, id);
        //definimos la miga de pan en el OnInit porque necesitamos saber si estamos editando o creando un unevo usuario
        this.breadcrumb = [];
        this.breadcrumb.push({ label: 'Desenvolupament' });
        this.breadcrumb.push({ label: 'Configuració', url: 'developer/config' });
        if (!id) {
            this.breadcrumb.push({ label: 'Nou paràmetre' });
        }
        else {
            this.breadcrumb.push({ label: "Edició de paràmetre" });
        }
    };
    /** Limpia el formulario. */
    ConfigFormComponent.prototype.cleanForm = function () {
        _super.prototype.cleanForm.call(this);
        this.object = config_1.Config.newObject();
    };
    /** Cierra el formulario y vuelve a la pantalla anterior. */
    ConfigFormComponent.prototype.goBack = function () {
        this.router.navigate(['developer/config']);
    };
    Object.defineProperty(ConfigFormComponent.prototype, "diagnostic", {
        /** Información de debug. */
        get: function () { return JSON.stringify(this.object); },
        enumerable: true,
        configurable: true
    });
    ConfigFormComponent = __decorate([
        core_1.Component({
            selector: 'config-form',
            template: "\n      <bit-header [breadcrumb]=\"breadcrumb\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n\n      <form role=\"form\" [formGroup]=\"myForm\" (submit)=\"save()\">\n\n          <div class=\"form-group has-feedback\" id=\"seccion_0\">\n              <p-accordion class=\"acordeon\" [multiple]=\"true\">\n                  <p-accordionTab header=\"Dades del paràmetre\" [selected]=\"true\">\n                      <div class=\"row separador\">\n                          <div class=\"col-sm-12\">\n                              <bit-input [readOnly]=\"isEditMode\" [(ngModel)]=\"object.codigo\" nombre=\"codigo\" [control]=\"myForm.controls.codigo\" formControlName=\"codigo\" tipo=\"text\">&nbsp;&nbsp;Codi</bit-input>\n                          </div>\n                      </div>\n                      <div class=\"row separador\">\n                          <div class=\"col-sm-12\">\n                              <bit-input [(ngModel)]=\"object.valor\" nombre=\"valor\" [control]=\"myForm.controls.valor\" formControlName=\"valor\" tipo=\"textarea\">&nbsp;&nbsp;Valor</bit-input>\n                          </div>\n                      </div>\n                  </p-accordionTab>\n              </p-accordion>\n          </div>\n      </form>\n\n      <bit-footer [paginator]=\"false\" type=\"form\" [status]=\"status\" [messages]=\"messages\"></bit-footer>\n    "
        }),
        __metadata("design:paramtypes", [configuracion_service_1.ConfiguracionService,
            router_1.Router,
            router_1.ActivatedRoute,
            message_service_1.MessageService,
            toolbar_service_1.ToolbarService,
            forms_1.FormBuilder])
    ], ConfigFormComponent);
    return ConfigFormComponent;
}(base_form_component_1.BaseFormComponent));
exports.ConfigFormComponent = ConfigFormComponent;
//# sourceMappingURL=config-form.component.js.map