"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var configuracion_service_1 = require("../shared/service/configuracion.service");
var config_filter_1 = require("../shared/data/config.filter");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var message_service_1 = require("../../shared/service/message.service");
var base_list_component_1 = require("../../base/component/base-list.component");
var bit_toolbar_component_1 = require("../../shared/component/bit-toolbar.component");
var ConfigListComponent = /** @class */ (function (_super) {
    __extends(ConfigListComponent, _super);
    // Tenemos una referencia al componente hijo que contiene el filtro 
    //@ViewChild(TipoDatoListFilterComponent) tipoDatoListFilterComponent: TipoDatoListFilterComponent;
    function ConfigListComponent(configService, messageService, toolbarService, activatedRoute, router) {
        var _this = _super.call(this, configService, messageService, activatedRoute, router, toolbarService) || this;
        _this.configService = configService;
        _this.messageService = messageService;
        _this.toolbarService = toolbarService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.breadcrumb.push({ label: 'Desenvolupament' });
        _this.breadcrumb.push({ label: 'Configuració' });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas */
    ConfigListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, config_filter_1.ConfigFilter.newObject());
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].enable = true;
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].visible = true;
        this.toolbar[bit_toolbar_component_1.BitToolbarComponent.NEW_BUTTON].estilo = "fa fa-database";
        this.updateToolbar();
        this.search(false); // no hay filtro ni paginación, buscamos nada más entrar
    };
    ConfigListComponent.prototype.prepareDataForSubmit = function () { };
    ConfigListComponent = __decorate([
        core_1.Component({
            selector: 'config-list',
            template: "\n        <bit-header [breadcrumb]=\"breadcrumb\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n        <config-list-tableview [items]=items></config-list-tableview> \n        <bit-footer [autoQueryObs]=\"autoQuerySubject.asObservable()\" [totalItems]=\"totalItems\" [status]=\"status\" type=\"list\" [paginator]=\"true\" (onPageChange)=\"onPageChange($event)\" (onNewPageSize)=\"onNewPageSize($event)\"></bit-footer>\n    "
        }),
        __metadata("design:paramtypes", [configuracion_service_1.ConfiguracionService,
            message_service_1.MessageService,
            toolbar_service_1.ToolbarService,
            router_1.ActivatedRoute,
            router_1.Router])
    ], ConfigListComponent);
    return ConfigListComponent;
}(base_list_component_1.BaseListComponent));
exports.ConfigListComponent = ConfigListComponent;
//# sourceMappingURL=config-list.component.js.map