"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var log_service_1 = require("../shared/service/log.service");
var log_filter_1 = require("../shared/data/log.filter");
var message_service_1 = require("../../shared/service/message.service");
var base_list_component_1 = require("../../base/component/base-list.component");
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
var LogListNoFiltroComponent = /** @class */ (function (_super) {
    __extends(LogListNoFiltroComponent, _super);
    function LogListNoFiltroComponent(logService, messageService, activatedRoute, router) {
        var _this = _super.call(this, logService, messageService, activatedRoute, router) || this;
        _this.logService = logService;
        _this.messageService = messageService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        return _this;
    }
    /** Construimos un filtro manual, desactivamos el botón de filtro del toolbar y buscamos 50 elementos sin paginación*/
    LogListNoFiltroComponent.prototype.ngOnInit = function () {
        this.filter = new log_filter_1.LogFilter("", "", "", "", null, false, 50, 1);
        this.toolbar["filter"].visible = false;
        this.search();
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    LogListNoFiltroComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    LogListNoFiltroComponent = __decorate([
        core_1.Component({
            selector: 'log-list',
            template: "   \n   <bit-header [toolbar]=toolbar (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n   <log-list-tableview [items]=items></log-list-tableview>\n   <bit-footer [autoQueryObs]=\"autoQuerySubject.asObservable()\" [totalItems]=\"totalItems\" [status]=\"status\"></bit-footer>\n   "
        }),
        __metadata("design:paramtypes", [log_service_1.LogService,
            message_service_1.MessageService,
            router_1.ActivatedRoute,
            router_1.Router])
    ], LogListNoFiltroComponent);
    return LogListNoFiltroComponent;
}(base_list_component_1.BaseListComponent));
exports.LogListNoFiltroComponent = LogListNoFiltroComponent;
//# sourceMappingURL=log-list-nofiltro.component.js.map