"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var message_service_1 = require("../../shared/service/message.service");
var bitmessage_1 = require("../../shared/data/bitmessage");
var LogListTableViewComponent = /** @class */ (function () {
    function LogListTableViewComponent(messageService) {
        this.messageService = messageService;
    }
    /** Muestra los datos de log en un diálogo*/
    LogListTableViewComponent.prototype.showDatosLog = function (event, log, titulo) {
        var width = bitmessage_1.BitMessage.WIDTH;
        var json = true;
        if (titulo === 'Error') {
            width = 800;
            json = false;
        }
        var bitMessage = new bitmessage_1.BitMessage(titulo, log, width);
        bitMessage.json = json;
        this.messageService.sendMessage(bitMessage);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], LogListTableViewComponent.prototype, "items", void 0);
    LogListTableViewComponent = __decorate([
        core_1.Component({
            selector: 'log-list-tableview',
            template: "\n<p-dataTable [value]=\"items\" *ngIf=\"(items != null && items.length > 0)\">\n    <p-column field=\"login\" header=\"Login\" [sortable]=\"true\"></p-column>\n    <p-column field=\"concepto\" header=\"Concepto\" [sortable]=\"true\"></p-column>\n    <p-column field=\"tipo\" header=\"Operaci\u00F3n\" [sortable]=\"true\"></p-column>\n    <p-column field=\"fecha\" header=\"Hora\" [sortable]=\"true\">\n        <ng-template let-log=\"rowData\" pTemplate type=\"body\">\n            <span>{{log.fecha | date:\"HH:mm\"}}</span>\n        </ng-template>\n    </p-column> \n    <p-column styleClass=\"col-button\">\n        <ng-template let-log=\"rowData\" pTemplate type=\"body\">\n            <div class=\"btn-group\" role=\"group\">\n                <button [disabled]=\"!log.datos\" class=\"btn btn-default btn-xs\"  (click)=\"showDatosLog($event,log.datos,'Dades enviades');\">Enviat&nbsp;&nbsp;<span class=\"glyphicon glyphicon-log-in\"></span></button>\n            </div>\n            <div class=\"btn-group\" role=\"group\">\n                <button *ngIf=\"!log.error && log.respuesta\" class=\"btn btn-default btn-xs\" (click)=\"showDatosLog($event,log.respuesta,'Resposta');\"> Resposta&nbsp;&nbsp;<span class=\"glyphicon glyphicon-log-out\"></span>\n                </button>\n                <button *ngIf=\"log.error\" class=\"btn btn-danger btn-xs\" (click)=\"showDatosLog($event,log.error,'Error');\"> Error&nbsp;&nbsp;<span class=\"glyphicon glyphicon-alert\"></span>\n                </button>\n            </div>\n        </ng-template>\n    </p-column>\n</p-dataTable>\n    "
        }),
        __metadata("design:paramtypes", [message_service_1.MessageService])
    ], LogListTableViewComponent);
    return LogListTableViewComponent;
}());
exports.LogListTableViewComponent = LogListTableViewComponent;
//# sourceMappingURL=log-list-tableview.component.js.map