"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var log_list_filter_component_1 = require("./log-list-filter.component");
var log_service_1 = require("../shared/service/log.service");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var base_list_component_1 = require("../../base/component/base-list.component");
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
var LogListComponent = /** @class */ (function (_super) {
    __extends(LogListComponent, _super);
    function LogListComponent(logService, messageService, activatedRoute, router, toolbarService) {
        var _this = _super.call(this, logService, messageService, activatedRoute, router, toolbarService) || this;
        _this.logService = logService;
        _this.messageService = messageService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.toolbarService = toolbarService;
        _this.breadcrumb.push({ label: 'Desenvolupament', url: 'developer/exceptions' }); //es un ejemplo
        _this.breadcrumb.push({ label: 'Log' });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas. Pasamos el objeto filtro de nuestro hijo para realizar esa
     * hipotética autobúsqueda
     */
    LogListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, this.logListFilterComponent.filter);
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    LogListComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    __decorate([
        core_1.ViewChild(log_list_filter_component_1.LogListFilterComponent),
        __metadata("design:type", log_list_filter_component_1.LogListFilterComponent)
    ], LogListComponent.prototype, "logListFilterComponent", void 0);
    LogListComponent = __decorate([
        core_1.Component({
            selector: 'log-list',
            template: "   \n    <bit-header [breadcrumb]=breadcrumb (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n    <log-list-filter [displayFilter]=\"true\" (onSearch)=\"onSearch($event)\" (onReset)=onReset($event)></log-list-filter>\n    <log-list-tableview [items]=items></log-list-tableview>  \n    <bit-footer [autoQueryObs]=\"autoQuerySubject.asObservable()\" [totalItems]=\"totalItems\" [status]=\"status\" type=\"list\" [paginator]=\"true\" (onPageChange)=\"onPageChange($event)\" (onNewPageSize)=\"onNewPageSize($event)\"></bit-footer>\n    "
        }),
        __metadata("design:paramtypes", [log_service_1.LogService,
            message_service_1.MessageService,
            router_1.ActivatedRoute,
            router_1.Router,
            toolbar_service_1.ToolbarService])
    ], LogListComponent);
    return LogListComponent;
}(base_list_component_1.BaseListComponent));
exports.LogListComponent = LogListComponent;
//# sourceMappingURL=log-list.component.js.map