import { Observable } from 'rxjs';
import { HttpUtilsService } from '../../../shared/service/http-utils.service';
import { MessageService } from '../../../shared/service/message.service';
import { LogFilter } from '../data/log.filter';
import { BaseCRUDService } from '../../../base/shared/base.service';
export declare class LogService extends BaseCRUDService {
    protected messageService: MessageService;
    protected http: HttpUtilsService;
    private countAllLogsByFilterUrl;
    private getAllLogsByFilterUrl;
    private getDominiosLogUrl;
    constructor(messageService: MessageService, http: HttpUtilsService);
    getAllByFilter<T>(logFilter: LogFilter): Observable<T>;
    countAllByFilter(logFilter: LogFilter): Observable<number>;
}
