"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var forms_1 = require("@angular/forms");
var forms_2 = require("@angular/forms");
var configuration_editor_1 = require("../data/configuration-editor");
var noop = function () { };
var ɵ0 = noop;
exports.ɵ0 = ɵ0;
exports.CUSTOM_BITEDITOROLD_CONTROL_VALUE_ACCESSOR = {
    provide: forms_2.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitEditorOldComponent; }),
    multi: true
};
/**
 * Clase que utiliza un custom componente para campo editor de HTML
 * Utiliza la interfaz ControlValueAccessor
 *    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
 * Para utilizar, importar tambien js y css.
 *
 * https://www.primefaces.org/primeng/#/editor
 * https://quilljs.com/docs/modules/toolbar/
 *
 **/
var BitEditorOldComponent = /** @class */ (function () {
    function BitEditorOldComponent() {
        this.tipo = "default";
        // si es "custom", se utiliza el objeto de configuracion: configuration.
        // si es "default", no se utiliza ninguna configuracion (se muestran todos los controles)
        this.configuration = BitEditorOldComponent_1.globalConfiguration;
        this.placeholder = "";
        this.readOnly = false;
        this.height = 100;
        this.hideLabel = false; // forzar que no se reserve espacio para el nombre del campo
        this.forceObligatorio = false;
        this.onChange = new core_2.EventEmitter();
        // bit-editor de un proyecto
        this.innerValue = "";
        this.onTouchedCallback = noop;
        this.onChangeCallback = noop;
    }
    BitEditorOldComponent_1 = BitEditorOldComponent;
    Object.defineProperty(BitEditorOldComponent.prototype, "value", {
        //get accessor
        get: function () {
            return this.innerValue;
        },
        //set accessor including call the onchange callback
        set: function (v) {
            if (v !== this.innerValue) {
                this.innerValue = v;
                this.onChangeCallback(v);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BitEditorOldComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null) {
                return "";
            } // si es null o undefined (es lo que evalúa el "==null")
            else {
                return this.value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BitEditorOldComponent.prototype.changed = function (event) {
        if (event.htmlValue != this.innerValue) {
            this.onTouchedCallback();
            this.onChangeCallback(this.innerValue);
            this.onChange.emit(event);
        }
    };
    BitEditorOldComponent.prototype.onFocus = function () {
        this.onTouchedCallback();
        // this.onChangeCallback(this.innerValue);
    };
    BitEditorOldComponent.prototype.onInit = function (quill) {
        /*var toolbar = quill.editor.getModule('toolbar');
            toolbar.addHandler('link', function(value) {
                if (value) {
                    var href = prompt('Introduzca la URL');
                    this.quill.format('link', href);
                } else {
                    this.quill.format('link', false);
                }
            });*/
    };
    BitEditorOldComponent.prototype.writeValue = function (value) {
        if (value !== this.innerValue) {
            this.innerValue = value;
        }
    };
    BitEditorOldComponent.prototype.registerOnChange = function (fn) {
        this.onChangeCallback = fn;
    };
    BitEditorOldComponent.prototype.registerOnTouched = function (fn) {
        this.onTouchedCallback = fn;
    };
    Object.defineProperty(BitEditorOldComponent.prototype, "obligatorio", {
        // decidimos marcar el campo como obligatorio si se ha indicado a la fuerza (por parámetro)
        // o si el control de formulario asociado está saltando por ser obligatorio y no haberse rellenado
        get: function () {
            return this.forceObligatorio || (this.control && this.control.errors && this.control.errors["required"]);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BitEditorOldComponent.prototype, "configuracion", {
        get: function () {
            return this.configuration ? this.configuration : BitEditorOldComponent_1.globalConfiguration;
        },
        enumerable: true,
        configurable: true
    });
    var BitEditorOldComponent_1;
    BitEditorOldComponent.globalConfiguration = configuration_editor_1.ConfigurationEditor.newObject(); // es posible tener configuraciones globales en todos los
    __decorate([
        core_2.Input(),
        __metadata("design:type", forms_1.FormControl)
    ], BitEditorOldComponent.prototype, "control", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Object)
    ], BitEditorOldComponent.prototype, "nombre", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitEditorOldComponent.prototype, "tipo", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", configuration_editor_1.ConfigurationEditor)
    ], BitEditorOldComponent.prototype, "configuration", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitEditorOldComponent.prototype, "placeholder", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitEditorOldComponent.prototype, "readOnly", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Number)
    ], BitEditorOldComponent.prototype, "height", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitEditorOldComponent.prototype, "hideLabel", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Boolean)
    ], BitEditorOldComponent.prototype, "forceObligatorio", void 0);
    __decorate([
        core_2.Output(),
        __metadata("design:type", Object)
    ], BitEditorOldComponent.prototype, "onChange", void 0);
    BitEditorOldComponent = BitEditorOldComponent_1 = __decorate([
        core_1.Component({
            selector: "bit-editor-old",
            template: "",
            providers: [exports.CUSTOM_BITEDITOROLD_CONTROL_VALUE_ACCESSOR]
        }),
        __metadata("design:paramtypes", [])
    ], BitEditorOldComponent);
    return BitEditorOldComponent;
}());
exports.BitEditorOldComponent = BitEditorOldComponent;
//# sourceMappingURL=bit-editor.component.js.map