"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var message_service_1 = require("../service/message.service");
var BitNotificationComponent = /** @class */ (function () {
    function BitNotificationComponent(messageService) {
        var _this = this;
        this.notificationMessages = [];
        this.errorMessages = [];
        //avisoService.initAvisosPedientes();  //hacer su propio componente que cargue los avisos
        //console.log("DialogComponent contructor(" + messageService  + ")");
        //Nos suscribimos a la espera de que envíen notificaciones
        this.subscriptionNotifications = messageService.observableNotifications.subscribe(function (message) {
            _this.showMessage(message);
        });
        //Nos suscribimos a la espera de que envíen notificaciones de error
        this.subscriptionNotificationsErrors = messageService.observableNotificationsErrors.subscribe(function (notificationError) {
            _this.showNotificationError(notificationError);
        });
    }
    BitNotificationComponent.prototype.showMessage = function (message) {
        this.notificationMessages = [];
        this.notificationMessages.push({ severity: message.severity, summary: message.title, detail: message.message });
    };
    BitNotificationComponent.prototype.showNotificationError = function (notificationError) {
        this.errorMessages = [];
        if (notificationError.multipleText) {
            for (var _i = 0, _a = notificationError.multipleText; _i < _a.length; _i++) {
                var error = _a[_i];
                this.errorMessages.push({ severity: 'error', summary: notificationError.textCA || notificationError.text, detail: error });
            }
        }
        else {
            this.errorMessages.push({ severity: 'error', summary: notificationError.textCA || notificationError.text, detail: notificationError.masInfo });
        }
    };
    BitNotificationComponent.prototype.ngOnDestroy = function () {
        // prevent memory leak when component destroyed
        this.notificationMessages = null;
        this.errorMessages = null;
        this.subscriptionNotifications.unsubscribe();
        this.subscriptionNotificationsErrors.unsubscribe();
    };
    BitNotificationComponent.MENSAJE_VOID = "No hi ha dades per mostrar";
    BitNotificationComponent = __decorate([
        core_1.Component({
            selector: 'bit-notification',
            template: "\n  <p-growl [value]=\"notificationMessages\"></p-growl>\n  <p-messages [value]=\"errorMessages\" [closable]=\"true\"></p-messages>\n"
        }),
        __metadata("design:paramtypes", [message_service_1.MessageService])
    ], BitNotificationComponent);
    return BitNotificationComponent;
}());
exports.BitNotificationComponent = BitNotificationComponent;
//# sourceMappingURL=bit-notification.component.js.map