"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
/**
 * Componenente que muestra la miga de pan en función de los datos de entrada. Estos datos corresponden con
 * un array de objetos que tendrán tres campos: label, url y params. El label debe ser obligatorio y corresponde con la
 * información en pantalla a mostrar. La url y params son opcionales y correposnden con la dirección a la que el usuario podrá ir
 * si pulsa en ella.
 * Ejemplos: [
 *              {label: 'Desenvolupament', url: 'developer/exceptions'},
 *              {label: 'Log'},
 *              {label: 'Usuaris', url: 'mantenimiento/users', params: {query: 'true'}}
 *            ]
 **/
var BitStoreBreadCrumbComponent = /** @class */ (function () {
    function BitStoreBreadCrumbComponent(router) {
        this.router = router;
    }
    /** Comprobamos si los datos de entrada no están definidos para inicializarlos en blanco */
    BitStoreBreadCrumbComponent.prototype.ngOnInit = function () {
        if (this.bc == undefined)
            this.bc = [];
        if (this.bc.length == 0)
            this.bc.push({ label: " " });
    };
    /** Vamos a la URL que contenga el path */
    BitStoreBreadCrumbComponent.prototype.goAddress = function (path) {
        if (path.params) {
            this.router.navigate([path.url, path.params]);
        }
        else {
            this.router.navigate([path.url]);
        }
        return false; //para evitar que navegue al href="#"
    };
    __decorate([
        core_1.Input("breadcrumb"),
        __metadata("design:type", Array)
    ], BitStoreBreadCrumbComponent.prototype, "bc", void 0);
    BitStoreBreadCrumbComponent = __decorate([
        core_1.Component({
            selector: "bit-store-breadcrumb",
            changeDetection: core_1.ChangeDetectionStrategy.OnPush,
            template: "\n      <ol class=\"breadcrumb\"> \n          <li [class.active]=\"i == (bc.length - 1)\" *ngFor=\"let path of bc; let i=index\">\n              <a *ngIf=\"i < (bc.length - 1) && path.url\" (click)=\"goAddress(path);\" href=\"#\">{{path.label}}</a>\n              <span *ngIf=\"i == (bc.length - 1) || !path.url\">{{path.label}}</span>\n          </li>\n      </ol>\n"
        }),
        __metadata("design:paramtypes", [router_1.Router])
    ], BitStoreBreadCrumbComponent);
    return BitStoreBreadCrumbComponent;
}());
exports.BitStoreBreadCrumbComponent = BitStoreBreadCrumbComponent;
//# sourceMappingURL=bit-store-breadcrumb.component.js.map