"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var ayuda_service_1 = require("../../service/ayuda.service");
var general_utils_service_1 = require("../../service/general-utils.service");
var bit_calendar_component_1 = require("./bit-calendar.component");
exports.CUSTOM_INPUT_DATE_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitDateComponent; }),
    multi: true
};
var BitDateComponent = /** @class */ (function (_super) {
    __extends(BitDateComponent, _super);
    function BitDateComponent(ayudaService, changeDetectorRef) {
        var _this = _super.call(this, ayudaService, changeDetectorRef) || this;
        _this.ayudaService = ayudaService;
        _this.changeDetectorRef = changeDetectorRef;
        return _this;
    }
    BitDateComponent.prototype.transformData = function (value) {
        var v;
        if (value) {
            v = general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringToDate(value));
        }
        return v;
    };
    Object.defineProperty(BitDateComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null || this.value == "") {
                return "";
            } // si es null o undefined (es lo que evalúa el "==null")
            else {
                return general_utils_service_1.GeneralUtils.getDateAsString(general_utils_service_1.GeneralUtils.stringShortToDate(this.value));
            }
        },
        enumerable: true,
        configurable: true
    });
    BitDateComponent = __decorate([
        core_1.Component({
            selector: "bit-date",
            template: "\n    <label *ngIf=\"!hideLabel\">\n        <ng-content></ng-content>&nbsp;<span *ngIf=\"obligatorio\" class=\"obligatorio fa fa-asterisk\"></span>&nbsp;&nbsp;\n        <i *ngIf=\"ayuda\" class=\"btn-ayuda fa fa-question\" (click)=\"showAyuda()\"></i>\n    </label>\n    <p *ngIf=\"readOnly\" class=\"lectura\" [id]=\"nombre\">{{value_lectura}}</p>\n    <p-calendar \n        *ngIf=\"!readOnly\"\n        class=\"FormControl\" \n        id=\"{{nombre}}\" \n        name=\"{{nombre}}\"    \n        [(ngModel)]=\"value\"                     \n        dateFormat=\"dd/mm/yy\" \n        placeholder=\"dd/mm/yyyy\" \n        [monthNavigator]=\"true\" \n        [readonlyInput]=\"calendarReadOnlyInput\"\n        [minDate]=\"fechaMinima\" \n        [maxDate]=\"fechaMaxima\"\n        [yearNavigator]=\"true\" \n        yearRange=\"2000:2030\" \n        [locale]=\"LOCALE_ES\">\n    </p-calendar>\n    <span *ngIf=\"!readOnly\" class=\"glyphicon glyphicon-calendar icono-input\"></span>\n    <control-messages *ngIf=\"control != null\" [control]=\"control\" [field]=\"nombre\"></control-messages>\n  ",
            providers: [exports.CUSTOM_INPUT_DATE_CONTROL_VALUE_ACCESSOR]
        }),
        __metadata("design:paramtypes", [ayuda_service_1.AyudaService, core_1.ChangeDetectorRef])
    ], BitDateComponent);
    return BitDateComponent;
}(bit_calendar_component_1.BitCalendarComponent));
exports.BitDateComponent = BitDateComponent;
//# sourceMappingURL=bit-date.component.js.map