"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var core_2 = require("@angular/core");
var forms_1 = require("@angular/forms");
var configuration_editor_1 = require("../../data/configuration-editor");
var bit_custom_component_1 = require("./bit-custom.component");
var ayuda_service_1 = require("../../service/ayuda.service");
exports.CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: core_1.forwardRef(function () { return BitEditorComponent; }),
    multi: true
};
/**
 * Clase que utiliza un custom componente para campo editor de HTML
 * Utiliza la interfaz ControlValueAccessor
 *    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
 * Para utilizar, importar tambien js y css.
 *
 * https://www.primefaces.org/primeng/#/editor
 * https://quilljs.com/docs/modules/toolbar/
 *
 **/
var BitEditorComponent = /** @class */ (function (_super) {
    __extends(BitEditorComponent, _super);
    function BitEditorComponent(ayudaService, changeDetectorRef) {
        var _this = _super.call(this, ayudaService, changeDetectorRef) || this;
        _this.ayudaService = ayudaService;
        _this.changeDetectorRef = changeDetectorRef;
        _this.tipo = "default";
        // si es "custom", se utiliza el objeto de configuracion: configuration.
        // si es "default", no se utiliza ninguna configuracion (se muestran todos los controles)
        _this.configuration = BitEditorComponent_1.globalConfiguration;
        _this.height = 100;
        return _this;
    }
    BitEditorComponent_1 = BitEditorComponent;
    Object.defineProperty(BitEditorComponent.prototype, "value_lectura", {
        get: function () {
            if (this.value == null) {
                return "";
            } // si es null o undefined (es lo que evalúa el "==null")
            else {
                return this.value;
            }
        },
        enumerable: true,
        configurable: true
    });
    BitEditorComponent.prototype.onFocus = function () {
        this.onTouchedCallback();
    };
    BitEditorComponent.prototype.onInit = function (quill) {
        /*var toolbar = quill.editor.getModule('toolbar');
            toolbar.addHandler('link', function(value) {
                if (value) {
                    var href = prompt('Introduzca la URL');
                    this.quill.format('link', href);
                } else {
                    this.quill.format('link', false);
                }
            });*/
    };
    Object.defineProperty(BitEditorComponent.prototype, "configuracion", {
        get: function () {
            return this.configuration ? this.configuration : BitEditorComponent_1.globalConfiguration;
        },
        enumerable: true,
        configurable: true
    });
    var BitEditorComponent_1;
    // es posible tener configuraciones globales en todos los bit-editor de un proyecto
    BitEditorComponent.globalConfiguration = configuration_editor_1.ConfigurationEditor.newObject();
    __decorate([
        core_2.Input(),
        __metadata("design:type", String)
    ], BitEditorComponent.prototype, "tipo", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", configuration_editor_1.ConfigurationEditor)
    ], BitEditorComponent.prototype, "configuration", void 0);
    __decorate([
        core_2.Input(),
        __metadata("design:type", Number)
    ], BitEditorComponent.prototype, "height", void 0);
    BitEditorComponent = BitEditorComponent_1 = __decorate([
        core_1.Component({
            selector: "bit-editor",
            template: "\n    <label *ngIf=\"!hideLabel\">\n        <ng-content></ng-content>&nbsp;\n        <span *ngIf=\"obligatorio\" class=\"obligatorio fa fa-asterisk\"></span>&nbsp;&nbsp;\n        <i *ngIf=\"ayuda\" class=\"btn-ayuda fa fa-question\" (click)=\"showAyuda();\"></i>\n    </label>\n    <p *ngIf=\"readOnly\" class=\"lectura\">\n        {{(value_lectura && value_lectura!='')?value_lectura:'&nbsp;'}}\n    </p>\n    <p-editor \n        *ngIf=\"!readOnly && tipo=='custom'\" \n        id=\"{{nombre}}\" \n        name=\"{{nombre}}\"\n        [(ngModel)]=\"value\"\n        styleClass=\"editor\" \n        [placeholder]=\"placeholder\" \n        [style]=\"{'height':height+'px'}\"    \n        (onInit)=\"onInit($event)\">\n        <p-header>\n            <span class=\"ql-formats\" *ngIf=\"configuracion.fontSize\">\n                <select class=\"ql-size\">\n                    <option value=\"small\">Petita</option>\n                    <!-- Note a missing, thus falsy value, is used to reset to default -->\n                    <option selected>Mitjana</option>\n                    <option value=\"large\">Gran</option>\n                    <option value=\"huge\">Molt gran</option>\n                </select>\n            </span>\n            <span class=\"ql-formats\" *ngIf=\"configuracion.fontFormat\">\n                <button class=\"ql-bold\" aria-label=\"Bold\"></button>\n                <button class=\"ql-italic\" aria-label=\"Italic\"></button>\n                <button class=\"ql-underline\" aria-label=\"Underline\"></button>\n                <button class=\"ql-strike\" aria-label=\"Strikethrough\"></button>\n            </span>\n            <span class=\"ql-formats\" *ngIf=\"configuracion.bullet\">\n                <button class=\"ql-list\" value=\"ordered\" type=\"button\"></button>\n                <button class=\"ql-list\" value=\"bullet\" type=\"button\"></button>\n            </span>\n            <span class=\"ql-formats\" *ngIf=\"configuracion.link\">\n                <button class=\"ql-link\" aria-label=\"Insert Link\" type=\"button\"></button>\n            </span>\n        </p-header>\n    </p-editor>\n    <!--(onTextChange)=\"changed($event)\"-->\n    <p-editor \n        *ngIf=\"!readOnly && (!tipo || tipo=='default')\" \n        id=\"{{nombre}}\" \n        name=\"{{nombre}}\" \n        [(ngModel)]=\"value\"\n        styleClass=\"editor\"         \n        [placeholder]=\"placeholder\" \n        [style]=\"{'height':height+'px'}\">\n    </p-editor>\n    <control-messages *ngIf=\"control!=null\" [control]=\"control\" [field]=\"nombre\"></control-messages>\n  ",
            providers: [exports.CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR]
        }),
        __metadata("design:paramtypes", [ayuda_service_1.AyudaService, core_1.ChangeDetectorRef])
    ], BitEditorComponent);
    return BitEditorComponent;
}(bit_custom_component_1.BitCustomComponent));
exports.BitEditorComponent = BitEditorComponent;
//# sourceMappingURL=bit-editor.component.js.map