import { EventEmitter, OnInit } from "@angular/core";
import { FormControl } from "@angular/forms";
import { AyudaService } from "../../service/ayuda.service";
/**
 *  Clase general que todos los componentes personalizados deben extender. Contiene toda la lógica común para trabajar con
 * componentes personalizados
 */
export declare abstract class BitGeneralComponent implements OnInit {
    protected ayudaService: AyudaService;
    control: FormControl;
    nombre: any;
    nombreDirectiva: any;
    label: string;
    estilo: string;
    tooltipTexto: string;
    tooltipPosicion: string;
    ayuda: string;
    placeholder: string;
    readOnly: boolean;
    hideLabel: boolean;
    instanciaPipe: any;
    forceObligatorio: boolean;
    onChange: EventEmitter<string>;
    constructor(ayudaService: AyudaService);
    /**Debemos suscribirnos a los cambios del FormControl para emitir mediante onChange el evento con el nuevo valor que tiene el componente */
    ngOnInit(): void;
    /** Controlamos si debemos modificar el valor interno del componente mediante una transformacion al tener un pipe asociado*/
    onBlur(): void;
    onFocus(): void;
    readonly obligatorio: boolean;
    showAyuda(): void;
    readonly value_lectura: string;
}
