"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = require("@ngrx/store");
var fromRouter = require("@ngrx/router-store");
exports.reducers = {
    routerReducer: fromRouter.routerReducer
};
// selector
exports.getRouterState = store_1.createFeatureSelector("routerReducer");
/*
 custom serializer que nos permite obtener la representación del estado de la URL donde nos encontramos en cada momento
 Registrando estsa clase conseguiermos que el RouterStore quedará escuchando eventos del Router, por lo que cada vez que naveguemos
 y accedamos a otra URL, esta clase se ejecutará para obtener esta nueva representación
*/
var CustomSerializer = /** @class */ (function () {
    function CustomSerializer() {
    }
    //Este método nos transforma el estado del router de Angular a nuestra propia estructura
    CustomSerializer.prototype.serialize = function (routerSate) {
        var url = routerSate.url; //same as url = routerSate.url;
        var queryParams = routerSate.root.queryParams;
        var state = routerSate.root;
        //El router es un árbol de estados sobre el que podemos iterar
        while (state.firstChild) {
            state = state.firstChild;
        }
        var params = state.params;
        //este objeto se linkará a nuestro árbol de estados
        return { url: url, queryParams: queryParams, params: params };
    };
    return CustomSerializer;
}());
exports.CustomSerializer = CustomSerializer;
//# sourceMappingURL=index.js.map